package dhm 
{
	import com.efg.framework.TileSheet;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	
	/**
	 * ...
	 * @author DHM
	 * 
	 * Partial rewrite of Fulton's class with a few changes:
	 * 1. No centering translation on the bitmap.
	 * 2. Som unused member variables has been removed.
	 * 3. Encapsulation has been improved.
	 */
	public class MyBlitSprite extends Sprite 
	{
		private var _bitmapData:BitmapData;
		private var _bitmap:Bitmap;
		private var _tileSheet:TileSheet;
		private var _sourceRect:Rectangle; 
		private var _destPoint:Point;
		private var _animationDelay:int=3;
		private var _animationCount:int = 0;
		private var _tileWidth:Number;
		private var _tileHeight:Number;
		private var _currentTile:int;
		private var _forceCopyPixels:Boolean = false;
		private var _tileList:Array;
		
		public var animationLoop:Boolean = false;
		
		public function MyBlitSprite(tileSheet:TileSheet, tileList:Array, firstFrame:int) 
		{
			_tileSheet = tileSheet;
			_tileWidth = tileSheet.tileWidth;
			_tileHeight = tileSheet.tileHeight;
			_tileList = tileList;
			_sourceRect = new Rectangle(0, 0, _tileWidth, _tileHeight);
			_destPoint = new Point(0, 0);
			_bitmapData = new BitmapData(_tileWidth, _tileHeight, true, 0x00000000);
			_bitmap = new Bitmap(_bitmapData);
			addChild(_bitmap);
			_currentTile = firstFrame;
			renderCurrentTile(true);
		}
		
		public function hitTestBitmap(firstPoint:Point, secondObject:Object):Boolean
		{
			return _bitmapData.hitTest(firstPoint, 1, secondObject);
		}
		
		public function updateCurrentTile():void 
		{
			if (animationLoop) 
			{
				if (_animationCount > _animationDelay) 
				{
					_animationCount = 0;
					_currentTile++;
					_forceCopyPixels = true;
					if (_currentTile > _tileList.length - 1) 
						_currentTile = 0;
				}
				_animationCount++;
			}
		}
		
		public function renderCurrentTile(forceCopyPixels:Boolean = false):void 
		{		
			if (forceCopyPixels)
				_forceCopyPixels = true;
			
			if (_forceCopyPixels) 
			{
				_bitmap.bitmapData.lock();
				_sourceRect.x = int(_tileList[_currentTile] % _tileSheet.tilesPerRow) * _tileWidth;
				_sourceRect.y = int(_tileList[_currentTile] / _tileSheet.tilesPerRow) * _tileHeight;
				_bitmap.bitmapData.copyPixels(_tileSheet.sourceBitmapData, _sourceRect, _destPoint);
				_bitmap.bitmapData.unlock();
			}
			
			_forceCopyPixels = false;
		}
		
		public function dispose():void 
		{
			_bitmap.bitmapData.dispose();
			_bitmap = null;
			_sourceRect = null;
			_destPoint = null;
			_tileList = null;
		}
		
		protected function updateTileList(tileList:Array):void
		{
			_tileList = tileList;
			_forceCopyPixels = true;
		}
	}
}