package dhm 
{
	import com.efg.framework.CustomEventSound;
	import flash.display.Sprite;
	import flash.filters.GlowFilter;
	import flash.geom.Point;
	
	/**
	 * ...
	 * @author DHM
	 */
	public class Pickup extends Sprite
	{
		private static const SIZE:int = 13;
		private static const SPIN_FRAMES:int = SIZE * 4;
		
		private var _alphaDelta:Number = -0.03;
		private var _animationFrame:int = 0;
		
		public var spawnPointIndex:int;
		
		public function Pickup(color:uint) 
		{
			alpha = 0.8;
			filters = [new GlowFilter(color, 0.8, 10, 10)];
			redraw();
		}
		
		public function Apply(contestant:Contestant):void 
		{
		}
		
		public function moveTo(center:Point):void
		{
			x = center.x - SIZE / 2;
			y = center.y - SIZE / 2;
		}
		
		public function render():void 
		{
			// fade in and out
			if (alpha >= 0.8)
				_alphaDelta = -0.03;
			else if(alpha <= 0.4)
				_alphaDelta = 0.04;
				
			alpha += _alphaDelta;
			
			_animationFrame = (_animationFrame + 1) % SPIN_FRAMES;
				
			if(_animationFrame % 2 == 0)
				redraw();
		}
		
		private function redraw():void
		{
			// bob and rotate
			var frame:int = _animationFrame / 2;
			var width:int = frame <= SIZE ? frame : SIZE * 2 - frame;
			var y:int = frame <= SIZE ? -frame : frame - SIZE * 2;
			graphics.clear();
			graphics.lineStyle(2, 0xFFFFFF);
			graphics.drawEllipse(-(width / 2), y, width, SIZE);
		}
	}
}