package dhm 
{
	import com.efg.framework.CustomEventSound;
	import com.efg.framework.TileSheet;
	import flash.geom.*;
	import flash.ui.Keyboard;
	
	/**
	 * ...
	 * @author DHM
	 * 
	 * Represents a human player.
	 */
	public class Player extends Contestant
	{
		private var _disk:Disk;
		
		public function Player(worldBounds:Rectangle)
		{
			_disk = new Disk(0x96C6FF, Settings.PLAYER_THROW_SPEED);
			
			super(new ImageLibrary.PlayerPng(), worldBounds, _disk, Settings.PLAYER_MOVE_SPEED, Settings.PLAYER_INITIAL_HEALTH);
		}
		
		public function throwWeapon(target:Point):Boolean
		{
			if (_disk.isInFlight || _disk.isBlocking)
				return false;
			_disk.launch(target);
			return true;
		}
		
		override public function hit(damage:int):void 
		{
			super.hit(damage);
			dispatchEvent(new CustomEventSound(CustomEventSound.PLAY_SOUND, SoundLibrary.SOUND_HIT_PLAYER, false, 1, 0));	
		}
		
		public function processKeboardInput(keyPressList:Array):void
		{
			var l:Boolean = keyPressList[Keyboard.LEFT] || keyPressList[65 /*'a'*/];
			var u:Boolean = keyPressList[Keyboard.UP] || keyPressList[87 /*'w'*/];
			var r:Boolean = keyPressList[Keyboard.RIGHT] || keyPressList[68 /*'d'*/];
			var d:Boolean = keyPressList[Keyboard.DOWN] || keyPressList[83 /*'s'*/];
			var block:Boolean = keyPressList[Keyboard.SPACE] && !_disk.isInFlight;
			
			var dx:int = 0;
			var dy:int = 0;
		
			_disk.isBlocking = block;
			
			if(!block)
			{
				if (l && !r)
					dx = -1;	
				else if (r && !l)
					dx = 1;
				if (u && !d)
					dy = -1;
				else if (d && !u)
					dy = 1;
			}
					
			updateDirection(dx, dy);
		}
	}
}