package dhm 
{
	import flash.filters.GlowFilter;
	/**
	 * ...
	 * @author DHM
	 */
	public class StunPole extends Weapon 
	{
		private var _glowFilter:GlowFilter = new GlowFilter(0xFFFFFFFF, 0.5);
		private var _disarmCounter:int = 0;
		
		public function StunPole() 
		{
			super(3);
			filters = [_glowFilter];
			_armed = true;
			redraw();
		}
		
		override public function onBlocked():void 
		{
			super.onBlocked();
			_armed = false;
			_disarmCounter = Settings.BLOCKED_STUNPOLE_DISARM_TIMEOUT;
			redraw();
		}
		
		override public function update():void 
		{
			super.update();
			
			if (!_armed)
			{
				if(_disarmCounter > 0)
					_disarmCounter--;
				else
				{
					_armed = true;
					redraw();
				}					
			}
		}
		
		override protected function redraw():void
		{
			var color:uint = _armed ? 0xFFFFFF : 0x888888;
			
			graphics.clear();
			graphics.lineStyle(1, color);
			graphics.beginFill(color);
			
			switch(facing)
			{
				case Facing.LEFT:
				case Facing.RIGHT:
					graphics.drawRect(0, 0, 15, 2);
					break;
				case Facing.DOWN:
				case Facing.UP:
					graphics.drawRect(0, 0, 2, 15);
					break;
			}
			
			graphics.endFill();
			
			filters = _armed ? [_glowFilter] : [];
		}
	}
}